// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();

    var serverName = widget.preferenceForKey( createInstancePreferenceKey( "serverName" ) );
    var username = widget.preferenceForKey( createInstancePreferenceKey( "username" ) );
    var directoryPath = widget.preferenceForKey( createInstancePreferenceKey( "directoryPath" ) );
    var listRecent = widget.preferenceForKey( createInstancePreferenceKey( "listRecent" ) );

    if ( typeof serverName != "undefined" ) {
        document.getElementById( "serverName" ).value = serverName;
    }
	if ( typeof username != "undefined" ) {
        document.getElementById( "username" ).value = username;
    }
    if ( typeof directoryPath != "undefined" ) {
        document.getElementById( "directoryPath" ).value = directoryPath;
    }
    if ( typeof listRecent != "undefined" ) {
        document.getElementById( "input" ).checked = listRecent;
    }

    doListing();   // Philip Salvaggio, Carl Salvaggio (27 September 2009)
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));

    widget.setPreferenceForKey( null, createInstancePreferenceKey( "serverName" ) );
    widget.setPreferenceForKey( null, createInstancePreferenceKey( "username" ) );
    widget.setPreferenceForKey( null, createInstancePreferenceKey( "directoryPath" ) );
    widget.setPreferenceForKey( null, createInstancePreferenceKey( "listRecent" ) );
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage

    var serverName = document.getElementById( "serverName" ).value;
    var username = document.getElementById( "username" ).value;
    var directoryPath = document.getElementById( "directoryPath" ).value;
    var listRecent = document.getElementById( "input" ).checked;

    widget.setPreferenceForKey( serverName, createInstancePreferenceKey( "serverName" ) );
    widget.setPreferenceForKey( username, createInstancePreferenceKey( "username" ) );
    widget.setPreferenceForKey( directoryPath, createInstancePreferenceKey( "directoryPath" ) );
    widget.setPreferenceForKey( listRecent, createInstancePreferenceKey( "listRecent" ) );
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide

    doListing();   // Philip Salvaggio, Carl Salvaggio (27 September 2009)
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }

    document.getElementById( "versionText" ).innerHTML = "Version " + getCurrentWidgetVersion();
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	
    doListing();   // Philip Salvaggio, Carl Salvaggio (27 September 2009)
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}




//
// Function: doListing()
// Retrieve the file listing from the remote server
//
// Modification History:  27 September 2009  Original Code (Philip Salvaggio, Carl Salvaggio)
// 
function doListing()
{
    //
    // Read the user provided parameters from the back of the widget
    //
    var serverName = document.getElementById( "serverName" ).value;
    var username = document.getElementById( "username" ).value;
    var directoryPath = document.getElementById( "directoryPath" ).value;
    var listRecent = document.getElementById( "input" ).checked;

    //
    // Clear the directory name on the widget front
    //
    document.getElementById( "directoryLabel" ).innerHTML = "Updating ...";

    //
    // Check that the server and user information are provided, parse off
    // the file count, and update the file listing in the content area
    //
    if ( (serverName.length != 0) && (username.length != 0) ) {
        var files = widget.system( "/usr/bin/php php/fileListing.php " + 
                                   username + " " + 
                                   serverName + " " + 
                                   listRecent + " " +
                                   directoryPath, null ).outputString;

        var numberFiles = "";
        var openTagIndex = files.indexOf( "<numberFiles>" );
        var closeTagIndex = files.indexOf( "</numberFiles>" );
        if ( (openTagIndex != -1) && (closeTagIndex != -1) ) {
           numberFiles = " (" + files.substring( openTagIndex+13, closeTagIndex ) + ")";
           files = files.substring( 0, openTagIndex );
        }

        document.getElementById( "content" ).innerHTML = files;

        document.getElementById( "directoryLabel" ).innerHTML = "";

        //
        // Capture any error conditions
        //
        var success = 1;
		if ( (files.substr( 0, 20 ) == "The provided directo") ||
		     (files.substr( 0, 20 ) == "The authentication i") ||
			 (files.substr( 0, 20 ) == "The provided server ") ) {
            success = 0;
        }

        if ( success == 1 ) {

            //
            // Remove any trailing slashes before parsing directory name for display
            //
            if ( (directoryPath.length > 1) && (directoryPath.lastIndexOf( "/" ) ==
                                                                    directoryPath.length-1) ) {
                directoryPath = directoryPath.substr( 0, directoryPath.length-1 );
            }

            //
            // Parse and display directory basename on the front of the widget
            //
            directoryParts = directoryPath.split( "/" );
            if ( directoryParts.length > 0 ) {
                document.getElementById( "directoryLabel" ).innerHTML = 
                                               directoryParts[ directoryParts.length-1 ] +
                                               numberFiles;
            }

        }

    //
    // If configuration information has not been provided, inform the user
    //
    } else {
        document.getElementById( "content" ).innerHTML = 
            "Please provide at least a server name and a username on the information panel";

        document.getElementById( "directoryLabel" ).innerHTML = "";
    }
}




//
// Function: getCurrentWidgetVersion()
// Reads the current version number from the widget's Info.plist included in the bundle
//
// Modification History:  28 September 2009  Original Code (http://macpomme.com/?p=35)
// 
function getCurrentWidgetVersion()
{
    var infoPlist = new XMLHttpRequest();
    infoPlist.open( "GET", "Info.plist", false );
    infoPlist.send( null );
    var infoXML = infoPlist.responseXML;
    var nodes = infoXML.getElementsByTagName( "dict" )[0].childNodes;

    var key_value = "";
    for ( var i=0; i<nodes.length; i++ ) {
        if ( nodes[i].nodeType == 1 && 
            nodes[i].tagName.toLowerCase() == "key" && 
            nodes[i].firstChild.data == "CFBundleVersion" ) {
            if ( nodes[i+2].tagName.toLowerCase() != "array" ) {
                key_value = nodes[i+2].firstChild.data;
            } else {
                key_value = new Array();
                var ar_nodes = nodes[i+2].childNodes;
                for ( var j=0; j<ar_nodes.length; j++ ) {
                    if ( ar_nodes[j].nodeType == 1 ) key_value.push( ar_nodes[j].firstChild.data );
                }
            }
            break;
        }
    }
    return key_value;
}
